classification
Title: IDLE cond context: fix code update and font update timers
Type: behavior Stage: resolved
Components: IDLE Versions: Python 3.7, Python 3.6
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: terry.reedy Nosy List: cheryl.sabella, terry.reedy
Priority: normal Keywords: patch

Created on 2017-09-16 20:47 by terry.reedy, last changed 2018-05-23 05:25 by terry.reedy. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 3622 merged terry.reedy, 2017-09-17 03:47
PR 3623 merged python-dev, 2017-09-17 04:57
Messages (6)
msg302352 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2017-09-16 20:47
1. Currently, each instance of codecontext.CodeContext creates 2 root.after loops.  There should be at most two loops for the class, and preferably fewer by using the new reload().

2. The loops are never explicitly shut down.  Since conversion to a feature,  the following appears after running test_idle.

.invalid command name "109891384timer_event"
    while executing
"109891384timer_event"
    ("after" script)
invalid command name "109891512font_timer_event"
    while executing
"109891512font_timer_event"
    ("after" script)

This is because of
  File "F:\dev\3x\lib\idlelib\idle_test\test_outwin.py", line 20, in setUpClass
    w = cls.window = outwin.OutputWindow(None, None, None, root)
  File "F:\dev\3x\lib\idlelib\outwin.py", line 78, in __init__
    EditorWindow.__init__(self, *args)
  File "F:\dev\3x\lib\idlelib\editor.py", line 319, in __init__
  text.bind("<<toggle-code-context>>",  # added to traceback
    self.CodeContext(self).toggle_code_context_event)

The statement, which creates an instance, was added as part of the conversion.  However, the outwin tests were merged a week before the conversion, so this message might have started the.  In any case, editor.EditorWindow.load_extension does the same thing in doing the binding.  It is not clear why there is no message from other editor-creating tests. 

I want to fix at least this before next Monday's cutoff for new releases.  I will first try is after_cancel in a __del__ method.
msg302359 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2017-09-17 04:56
New changeset a6bb313c70f8619e6dc4af5cef7d73fa3bbd59ca by Terry Jan Reedy in branch 'master':
bpo-31493: Fix code context update and font update timers. (#3622)
https://github.com/python/cpython/commit/a6bb313c70f8619e6dc4af5cef7d73fa3bbd59ca
msg302360 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2017-09-17 06:01
New changeset b417332bf44af93c8acda4b7197181d4b62c16a4 by Terry Jan Reedy (Miss Islington (bot)) in branch '3.6':
[3.6] bpo-31493: Fix code context update and font update timers. (GH-3622) (#3623)
https://github.com/python/cpython/commit/b417332bf44af93c8acda4b7197181d4b62c16a4
msg302628 - (view) Author: Cheryl Sabella (cheryl.sabella) * (Python committer) Date: 2017-09-20 15:38
Sorry, I didn't see this until now.

I added a line to editor.py in #31529 for this error message.  In _close() in editor.py, self.text was being set to None which wasn't calling the __del__ function of multicall.  I added a line to unbind "<<toggle-code-context>>", which made the error go away.  I don't know if that's the proper fix or not, but it seemed the error was occurring because the `after` wasn't being removed at the right time.
msg302706 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2017-09-21 16:25
The underlying issue is trying to coordinate two somewhat independent object systems (Python and Tcl).  I don't know why the after loops were (apparently) stopped before #27099 and not after.  The only difference I know of is the dropping of the reference to CodeContext instances in .unload_extensions, called from ._close.  CodeContext did not have a .close method.

I tried the first thing I thought might work and it did, so I stopped.  I don't know why unbinding the toggle function was enough.  I expect that we will eventually review ._close.  It should help when the menu and editor are separated a bit.
msg317360 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2018-05-23 05:25
The patch fixed immediate problem #2 above.  #1 is a separate enhancement and I listed it as #4 on the new master issue #33610.
History
Date User Action Args
2018-05-23 05:25:54terry.reedysetstatus: open -> closed
resolution: fixed
messages: + msg317360

stage: patch review -> resolved
2018-05-23 05:20:38terry.reedylinkissue33610 dependencies
2017-09-21 16:25:45terry.reedysetmessages: + msg302706
2017-09-20 15:38:02cheryl.sabellasetnosy: + cheryl.sabella
messages: + msg302628
2017-09-17 06:01:58terry.reedysetmessages: + msg302360
2017-09-17 04:57:11python-devsetpull_requests: + pull_request3613
2017-09-17 04:56:58terry.reedysetmessages: + msg302359
2017-09-17 03:47:06terry.reedysetkeywords: + patch
stage: needs patch -> patch review
pull_requests: + pull_request3612
2017-09-16 20:47:15terry.reedycreate